<?php
$globalMessage=""; //存取回的信息(Store retrieved message)
$globalServerUrl="";
$globalParams="";

function iisp_getConfigArray() {
	
	$configarray = array(
	 "Username" => array( "Type" => "text", "Size" => "20", "Description" => "Enter your username here", ),
	 "Password" => array( "Type" => "password", "Size" => "20", "Description" => "Enter your API password here", ),
	 "Email" => array( "Type" => "text", "Size" => "20", "Description" => "Enter your email here", ),
	);
	return $configarray;
}

//如果成功返回nameserver,失败返回error (If successful, return nameserver, if failed, return error)
function iisp_GetNameservers($params) {
	
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	# Put your code to get the nameservers here and return the values below, '成功返回：（最多6个）' means '[return successful: (6 at MAX)]'
	/*
	module:getdomaindns
	domainname:sld+tld
	成功返回：（最多6个）
	200 Command completed successfully
	nameserver1
	...
	nameserver6
	*/
	$_params=array(
		"testmode"=>$testmode,
		"action"=>"getdomaininfo", //域名注册 (domain registration)
		"domain"=>$sld.".".$tld, //注册域名 (register domain)
	);
	$result=com_iisp_api($params,$_params,$testmode);
	
	if(empty($result))
	{
		$error="return is null";
		
		# If error, return the error message in the value below
		$values["error"] = $error;
		return $values;	
	}
	
	if(com_iisp_getvalue($result,'returncode')==200)
	{
		$nameserver1=com_iisp_getvalue($results,'dns1');
		$nameserver2=com_iisp_getvalue($results,'dns2');
		$nameserver3=com_iisp_getvalue($results,'dns3');
		$nameserver4=com_iisp_getvalue($results,'dns4');

		$values["ns1"] = $nameserver1;
		$values["ns2"] = $nameserver2;
		$values["ns3"] = $nameserver3;
		$values["ns4"] = $nameserver4;

		return $values;
	} 
	
	# If error, return the error message in the value below
	$values["error"] = com_iisp_geterror($result);
	return $values;	
}

//如果成功,返回true,失败返回失败的原因 (if successful, return true, if failed, return the failure reason)
function iisp_SaveNameservers($params) {
	
	$userid = $params["Username"];
	$password = $params["Password"];
	$email = $params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
    $nameserver1 = $params["ns1"];
	$nameserver2 = $params["ns2"];
    $nameserver3 = $params["ns3"];
	$nameserver4 = $params["ns4"];
	# Put your code to save the nameservers here, 有多少参数就带多少过去 means 'along with all parameters'
	/*
	module:moddomaindns
	domainname:sld+tld
	dns_host:nameserver1
	...
	dns_host:nameserver6(有多少参数就带多少过去)
	*/
	$dnsHost="";
	
	if(!empty($nameserver1))
	{
		$dnsHost.="ANDdns_hostEQU".$nameserver1;
	}

	if(!empty($nameserver2))
	{
		$dnsHost.="ANDdns_hostEQU".$nameserver2;
	}

	if(!empty($nameserver3))
	{
		$dnsHost.="ANDdns_hostEQU".$nameserver3;
	}

	if(!empty($nameserver4))
	{
		$dnsHost.="ANDdns_hostEQU".$nameserver4;
	}

	$dnsHost=substr($dnsHost,strlen("ANDdns_hostEQU"));
	
	
	$_params=array(
		"userid"=>$userid,
		"action"=>"chgdns",
		"userstr"=>$userstr,
		"vtime"=>$vtime,
		"domain"=>$sld.".".$tld,
		"productid"=>$tld,
		"dnshost01"=>$nameserver1,
		"dnshost02"=>$nameserver2
	);
	
	$result=com_iisp_api($params,$_params,$testmode);
	if(empty($result))
	{
		$error="return is null";
		
		$values["error"] = $error;
		return $values;
	}

	if(com_iisp_getvalue($result,'returncode')==200)
	{
		return true;
	}

	# If error, return the error message in the value below
	$values["error"] = com_iisp_geterror($result);
	return $values;
}

//取得状态如果成功,返回状态,失败返回false (If getting status successful, return status, if failed, return false); Not Support this Function means 'currently not support such function'
function iisp_GetRegistrarLock($params) {
	
	$values["error"] = "Not Support this Function";
	return $values;
}

//如果成功返回true,失败返回失败的原因 (if successful, return true, if failed, return the failure reason)
function iisp_SaveRegistrarLock($params) {
	$values["error"] = "Not Support this Function";
	return $values;
}

//暂未做 (Unfinished)
function iisp_GetEmailForwarding($params) {
	$values["error"] = "Not Support this Function";
	return $values;
}

//暂未做 (Unfinished)
function iisp_SaveEmailForwarding($params) {
	$values["error"] = "Not Support this Function";
	return $values;
}

//成功返回数组,失败返回false (if successful, return array, if failed, return false)
function iisp_GetDNS($params) {
    $values["error"] = "Not Support this Function";
	return $values;
}

//修改dns,成功返回true,失败返回false (Modify DNS, if successful, return true, if failed, return false)
function iisp_SaveDNS($params) {
	
    $values["error"] = "Not Support this Function";
	return $values;
}

//注册,成功返回true,失败返回false (registration, if successful, return true, if failed, return false)
function iisp_RegisterDomain($params) {
	$userid = $params["Username"];
	$password = $params["Password"];
	$email = $params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];
	$nsserver1=$params["ns1"];
  	$nsserver2=$params["ns2"];
  	$nsserver3=$params["ns3"];
  	$nsserver4=$params["ns4"];
	
	if($nsserver1=="") $nsserver1='ns1.ndns.cn';
	if($nsserver2=="") $nsserver2='ns2.ndns.cn';
   
	# Registrant Details
	$RegistrantFirstName = $params["firstname"];
	$RegistrantLastName = $params["lastname"];
	# add by beeyon 2010-07-22 get "dom_org" value from companyname
	$RegistrantCompanyName = $params["companyname"];
	$RegistrantAddress1 =  $params["address1"];
	$RegistrantAddress2 =  $params["address2"];
	$RegistrantCity =  $params["city"];
	$RegistrantStateProvince =  $params["state"];
	$RegistrantPostalCode =  $params["postcode"];
	$RegistrantCountry =  $params["country"];
	$RegistrantEmailAddress =  $params["email"];
	$RegistrantPhone =  $params["phonenumber"];

	$DnsIp1=$params["dns_ip1"];
	$DnsIp2=$params["dns_ip2"];
	# Put your code to register domain here
	$_params=array(
		"userid"=>$userid,
		"userstr"=>$userstr,
		"vtime"=>$vtime,
		"category"=>"domain", //域名操作
		"action"=>"activate", //域名注册
		"domain"=>$sld.".".$tld, //注册域名
		"vyear"=>$regperiod,
		
		"dns1"=>$nsserver1, 
		"dns2"=>$nsserver2,  
		"name"=>$RegistrantFirstName.$RegistrantLastName, 
		"name_en"=>$RegistrantFirstName.$RegistrantLastName, 
		"productid"=>$tld,
		"domainpwd"=>substr(md5(time()),2,18),
		"organization_zh"=>$RegistrantCompanyName,
		"organization_en"=>$RegistrantCompanyName,
		"country"=>$RegistrantCountry,
		"address_zh"=>$RegistrantAddress1.$RegistrantAddress2,
		"address_en"=>$RegistrantAddress1.$RegistrantAddress2,
		"city"=>$RegistrantCity , 
		"state"=>$RegistrantStateProvince, 
		"postcode"=>$RegistrantPostalCode,
		"phone"=>$RegistrantPhone,
		"fax"=>$RegistrantPhone,
		"email"=>$RegistrantEmailAddress,
		"admin_same_as"=>1,
		"tech_same_as"=>1,
		"bill_same_as"=>1

	);
	
	$result=com_iisp_api($params,$_params,$testmode);

	# If error, return the error message in the value below
	if(empty($result))
	{
		return false;
	}

	if(com_iisp_getvalue($result,'returncode')==200)
	{
		return true;
	} 
	
	$values["error"]= com_iisp_geterror($result);
	return $values;
}

//如果转移成功,返回true,失败返回false (if transfer successful, return true, if faield, return false)
function iisp_TransferDomain($params) {
	$values["error"] = "Not Support this Function";
	return $values;
}

//域名续费,成功返回true,失败返回false (domain renewal, if successful, return true, if failed, return false)
function iisp_RenewDomain($params) {
	//print_r($params);die();
	$userid = $params["Username"];
	$password = $params["Password"];
	$email = $params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];


	$sql="select * from tbldomains where id=".$params["domainid"];
	$sqlquery=mysql_query($sql);
	$row = mysql_fetch_array($sqlquery);
	$days=$row[expirydate];
	$date_array = explode("-",$days); // split the array
	$yyyy=$date_array[0]+$regperiod;
	$mm=$date_array[1];
	$dd=$date_array[2];
	$new_date_format=$yyyy."-".$mm."-".$dd;
	# Put your code to renew domain here
	//print_r($row);die();
	$_params=array(
		
		"userid"=>$userid,
		"userstr"=>$userstr,
		"vtime"=>$vtime,
		"category"=>"domain",
		"action"=>"renew",
		"domain"=>$sld.".".$tld, 
		"deaddate"=>$new_date_format,
		"vyear"=>$regperiod
		
	);

	$result=com_iisp_api($params,$_params,$testmode);
	
	if(com_iisp_getvalue($result,'returncode')==200)
	{
		return true;
	}

	# If error, return the error message in the value below
	$values["error"] = com_iisp_geterror($result);
	return $values;
}

//如果成功,取回相应数组,失败返回false (if successful, retrieve the array, if failed, return false); 成功返回 means 'return successful'
function iisp_GetContactDetails($params) {
	$userid = $params["Username"];
	$password = $params["Password"];
	$email = $params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$productid=$tld;
	# Put your code to get WHOIS data here
	/*
	module:getcontactdetails
	domainname:sld+tld
	成功返回：
	200 Command completed successfully
	dom_fn：
	dom_ln：
	admi_fn:
	admi_ln:
	tech_fn:
	tech_ln:
	bill_fn:
	bill_ln:
	*/
	$_params=array(
		"action"=>"getdomaininfo",
		"userid"=>$userid,
		"vtime"=>$vtime,
		"userstr"=>$userstr,
		"productid"=>$productid,
		"domain"=>$sld.".".$tld
	);
	$result=com_iisp_api($params,$_params,$testmode);
	
	if(empty($result))
	{
		$values["error"] = "return is null";
		return $values;
	}
	if(com_iisp_getvalue($result,'returncode')==200)
	{
		$_result=explode("\r\n",$result);
		if(count($_result)>0)
		{
			for($i=1;$i<count($_result);$i++)
			{
				$arr_split=explode(':',$_result[$i]);
				$arr_results[$arr_split[0]]=$arr_split[1];
			}
		}
	}
	else
	{
		$error=$result;
	}
	
	
	# Data should be returned in an array as follows
	$values["Registrant"]["First Name"] = $arr_results['dom_fn'];
	$values["Registrant"]["Last Name"] = $arr_results['dom_ln'];
	$values["Registrant"]["Organization"] = $arr_results['dom_org'];
	$values["Registrant"]["Address"] = $arr_results['dom_adr1'];
	$values["Registrant"]["Address 2"] = $arr_results['dom_adr2'];
	$values["Registrant"]["City"] = $arr_results['dom_ct'];
	$values["Registrant"]["State"] = $arr_results['dom_st'];
	$values["Registrant"]["Country"] = $arr_results['dom_co'];
	$values["Registrant"]["Phone"] = $arr_results['dom_ph'];
	$values["Registrant"]["Email Address"] = $arr_results['dom_em'];
	$values["Registrant"]["Postcode"] = $arr_results['dom_pc'];

	
	return $values;
	
}

//修改联系人,成功返回true,失败返回false (modify contacts, if successful, return true, if failed, return false)
function iisp_SaveContactDetails($params) {
	//print_r($params);die();
	$userid = $params["Username"];
	$password = $params["Password"];
	$email = $params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	# Data is returned as specified in the GetContactDetails() function
	$dom_fn = $params["contactdetails"]["Registrant"]["First Name"];
	$dom_ln = $params["contactdetails"]["Registrant"]["Last Name"];
	$dom_org = $params["contactdetails"]["Registrant"]["Organization"];
	$dom_adr1 = $params["contactdetails"]["Registrant"]["Address"];
	$dom_adr2 = $params["contactdetails"]["Registrant"]["Address 2"];
	$dom_ct = $params["contactdetails"]["Registrant"]["City"];
	$dom_st = $params["contactdetails"]["Registrant"]["State"];
	$dom_co = $params["contactdetails"]["Registrant"]["Country"];
	$dom_ph = $params["contactdetails"]["Registrant"]["Phone"];
	$dom_em = $params["contactdetails"]["Registrant"]["Email Address"];
	$dom_pc = $params["contactdetails"]["Registrant"]["Postcode"];
	
	if(empty($bill_fn))
	{
		$bill_fn=$admi_fn;
	}
	if(empty($bill_ln))
	{
		$bill_ln=$bill_fn;
	}

	# Put your code to save new WHOIS data here
	/*
	module:savecontactdetails
	domainname:sld+tld
	dom_fn：
	dom_ln：
	admi_fn:
	admi_ln:
	tech_fn:
	tech_ln:
	bill_fn:
	bill_ln:
	成功返回：
	200 Command completed successfully
	dom_fn：
	dom_ln：
	admi_fn:
	admi_ln:
	tech_fn:
	tech_ln:
	bill_fn:
	bill_ln:
	*/
	$domainname=$sld.".".$tld;
	$_params=array(
		"userid"=>$userid,
		"userstr"=>$userstr,
		"vtime"=>$vtime,
		"changetype"=>"0",
		"domain"=>$domainname,
		"action"=>"chgcontact",
		"country"=>$dom_co,
		"city"=>$dom_ct,
		"state"=>$dom_st,
		"postcode"=>$dom_pc,
		"address"=>$dom_adr1,
		"address_en"=>$dom_adr2,
		"name"=>$dom_fn.$dom_ln, 
		"name_en"=>$dom_fn.$dom_ln, 
		"productid"=>$tld,
		"organization_zh"=>$dom_org,
		"organization_en"=>$dom_org,
		"phone"=>$dom_ph,
		"fax"=>$dom_ph,
		"email"=>$dom_em

		
	);
	$result=com_iisp_api($params,$_params,$testmode);
	if(empty($result))
	{
		$values["error"] = "return is null";
		return $values;
	}
	if(com_iisp_getvalue($result,'returncode')==200)
	{
		return true;
	}
	else
	{
		$error=$result;
		return true;
	}
	# If error, return the error message in the value below
	$values["error"] = $result;
	return $values;
}

//暂未完成 (unfinished)
function iisp_GetEPPCode($params) {
    $values["error"] = "Not Support this Function";
	return $values;
}

//注册ns,如果成功返回true,如果失败返回失败的原因 (register NS, if successful, return true, if failed, return the failure reason)
function iisp_RegisterNameserver($params) {
    $values["error"] = "Not Support this Function";
	return $values;
}

//修改NS,如果成功返回true,失败返回失败的原因 (modify NS, if successful, return true, if failed, return the failure reason)
function iisp_ModifyNameserver($params) {
    $values["error"] = "Not Support this Function";
	return $values;
}

//删除NS,如果成功就返回true,失败就返回false (delete NS, if successful, return true, if failed, return false)
function iisp_DeleteNameserver($params) {
    $values["error"] = "Not Support this Function";
	return $values;
}


function com_iisp_api($user_params,$params,$testModel=false)
{
	
	//define("COM_71_API_TEST","https://test.api.71.com/webrrpdomain");
	define("COM_NICENIC_API_TEST","apitest.nicenic.com");
	define("COM_NICENIC_API","api.nicenic.com");
	
	global $globalServerUrl,$globalMessage,$globalParams;

	if($testModel==true)
	{
		$postUrl=COM_NICENIC_API_TEST;
	}
	else
	{
		$postUrl=COM_NICENIC_API;
	}

	
	$userid = $user_params["Username"];
	$password = $user_params["Password"];
	$email = $user_params["Email"];
	$vtime = date("YmdHi");
	$userstr=md5($userid.$password.$email.$vtime);
	$params["userid"] = $userid;
	$params["userstr"] = $userstr;
	$params["vtime"] = $vtime;
	$params["category"] = "domain";


	$globalServerUrl=$postUrl;
	$sendParams=http_build_query($params,'',"&");
	$sendParams=str_replace("EQU","=",$sendParams);
	$sendParams=str_replace("AND","&",$sendParams);
	$globalParams=$sendParams;
	//print_r("http://".$postUrl.'?'.$globalParams);
	$results = my_file_get_contents("http://".$postUrl.'/?'.iconv('utf-8','gb2312',$globalParams));
	//$new_1 = com_iisp_getvalue($results,'returncode');
	//$new_2 = com_iisp_getvalue($results,'failreason');
	return $results;
}

function my_file_get_contents($url){
	//如果获取的是本地的文件, 则没有:// (if getting local files, no '://')
	if(strpos($url, "://")===false) return file_get_contents($url);
	$serverURL=eregi_replace("^http://","",$url);
	$pos=strpos($serverURL,"/");
	if($pos>0){
		$apiHost=substr($serverURL,0,$pos);
		$apiUrl=substr($serverURL,$pos);
	}else{
		$apiHost=$serverURL;
		$apiUrl="/";
	}
	$pos=strpos($apiHost,":");
	if($pos>0){
		$apiPort=substr($apiHost,$pos+1);
		$apiHost=substr($apiHost,0,$pos);
	}else $apiPort=80;
	
	$fp = @fsockopen($apiHost,$apiPort,$errno,$errstr,10) or exit($errstr."--->".$errno); 
	
	//构造post请求的头 (create the head of POST)
	$header = "GET ". $apiUrl . " HTTP/1.1\r\n";
	$header .= "Host:" . $apiHost . "\r\n";
	$header .= "Content-Type: application/x-www-form-urlencoded\r\n"; 
	$header .= "Connection: Close\r\n\r\n";
	//发送post的数据 (send POST data)
	@fputs($fp,$header); 
	$inheader = 1; 
	$ret="";
	while (!feof($fp)) {
		$line = @fgets($fp,1024); //去除请求包的头只显示页面的返回数据 (remove the head of request packet, only display the page return data)
		if ($inheader && ($line == "\n" || $line == "\r\n")) {
			 $inheader = 0; 
		} 
		if ($inheader == 0) { 
			$ret.=$line; 
		}
	}
	@fclose($fp);
	$ret = iconv('gb2312','utf-8',$ret);
	$ret = trim($ret);
	return $ret;
}
function com_iisp_getvalue($CutXml,$value){
	$key = $value;
	if (strpos($value, "-")) $value = substr($value, 0, strpos($value, "-"));
	$str1 = "<".$value;
	$str2 = "</".$value;
	$start_pos = strpos($CutXml, $str1);
	if ($start_pos > 0){
		$start_pos += strlen($str1);
		$CutXml = substr($CutXml, $start_pos);
		$end_pos = strpos($CutXml, $str2);
		$resValue = substr($CutXml, strpos($CutXml,">")+1, $end_pos-strpos($CutXml,">")-1);
	}
	return $resValue;
}
function com_iisp_geterror($results){
	return com_iisp_getvalue($results,'returncode').":".com_iisp_getvalue($results,'failreason');
}
?>
